/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	スマートフォースメニュー作成クラス
//			変更履歴
//				2004.01.08	新規作成	五木田 泰史
//

package jp.co.ntt.lms.lo.SmartForce;

import java.util.Hashtable;
import java.util.Vector;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.*;
import jp.co.ntt.lms.xmo.MenuData;

/**
 * WBTメニュー作成クラス
 *
 * <PRE>
 *   SmartForceLoのメニューを作成する。
 *   上位にメニュー作成インタフェースクラスを持つ。
 * </PRE>
 *
 */
public class SmartForceMenuMaker
	implements MenuMaker, SmartForceLoPropertyDef
{
	/**
	 * スマートフォースメニュー作成
	 *
	 * @param htbParam パラメータリスト
	 * @return MenuData[] スマートフォースメニュー配列
	 * @exception LOException Lo固有の例外エラー
	 */
	public MenuData[] makeMenu(Hashtable htbParam)
		throws LOException
	{
		try
		{
			// 管理アサイン情報の取得
			String strManageAssign = (String)htbParam.get( MANAGE_ASSIGN );
			// 学習アサイン情報の取得
			String strLearnerAssign = (String)htbParam.get( LEARNER_ASSIGN );
			// 学習権限情報の取得
			String strLearnAuth = (String)htbParam.get( LEARN_AUTH );
			// ログ参照権限の取得
			String strLogAuth = (String)htbParam.get( LOG_AUTH );
			// ログ取得時のターゲットとなるID設定キーの取得
			String strTarget = (String)htbParam.get( TARGET_ID );
			// 前提条件フラグの取得
			String strPrereFlg = (String)htbParam.get( PRERE_FLG );

			String strSetUp = (String)htbParam.get( SETUP_STATUS );
			Vector vecRet = new Vector();

			if( strLearnAuth != null &&
				strLearnerAssign != null &&
				strTarget != null)
			{
				String strUserID = (String)htbParam.get(USER);
				if(strUserID != null && strUserID.equals(strTarget) && strPrereFlg.equals("on"))
				{
					// 学習開始メニュー設定
					vecRet.add(makeStartLearnMenu(htbParam));
				}
			}
			if( strLogAuth != null &&
				( strManageAssign != null ||
				strLearnerAssign != null ) )
			{
				// 学習ログメニュー設定
				vecRet.add(makeLogMenu(htbParam));
			}
			if( strLogAuth != null &&
				( strManageAssign != null ||
				strLearnerAssign != null ) )
			{
				// 学習個別ログメニュー設定
				vecRet.add(makeIndividualLogMenu(htbParam));
			}
			// セットアップメニューの組み立て
			if( strSetUp != null ) {
				if( strSetUp.equals( SETUP_INSERT ) ) {
					// コンテナ登録メニュー設定
					vecRet.add(makeInsertMenu(htbParam));
				}
				else if( strSetUp.equals( SETUP_UPDATE ) ) {
					// コンテナ更新メニュー設定
					vecRet.add(makeUpdateMenu(htbParam));
				}
				else if( strSetUp.equals( SETUP_DELETE ) ) {
					// コンテナ削除メニュー設定
					vecRet.add(makeDeleteMenu(htbParam));
				}
			}
			// Vectorをメニューデータ配列型に変換
			MenuData[] objRet = new MenuData[vecRet.size()];
			vecRet.copyInto(objRet);
			return objRet;
		}
		catch(LOException le)
		{
			throw le;
		}
	}

	/**
	 * スマートフォース学習開始メニューオブジェクト作成
	 *
	 * @param htbParam パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeStartLearnMenu(Hashtable htbParam)
		throws LOException
	{
		// セッションIDの設定
		setSmartForceLoData(htbParam);

		String strMaterialID = (String)htbParam.get( COURSECODE );
		if( strMaterialID != null ) {
			htbParam.put( SESSIONID, strMaterialID );
		}
		// 環境ファイル読み込みクラスをインスタンス化
		SmartForceLoEnv objEnv = new SmartForceLoEnv();
		String strLearnURL     = objEnv.getStartLearnServletURL(htbParam);
		MenuData objMenu       = new MenuData(strLearnURL,
												"学習開始",
												MenuData.DEFAULT_MENU,
												MenuData.STUDENT_MENU);
		objMenu.setTargetWindow("SmartForce");
		return objMenu;
	}

	/**
	 * スマートフォース学習ログメニューオブジェクト作成
	 *
	 * @param htbParam パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeLogMenu(Hashtable htbParam)
		throws LOException
	{
		String strLoType        = (String)htbParam.get(LO_TYPE);
		String strUserID        = (String)htbParam.get(TARGET_ID);
		String strLoID          = (String)htbParam.get(LOID);
		String strReturnURL     = (String)htbParam.get(RETURN_URL);
		String strGroupID		= (String)htbParam.get(TARGET_PARENT_ID);
		String strLogURL        = "../LoLog/LoLogHomeWorkLog.vm?userId=" + strUserID +
									"&LoID=" + strLoID +
									"&belonggroupid=" + (strGroupID == null ? "": strGroupID) +
									"&LoType=" + strLoType +
									"&returnURL=" + strReturnURL;

		MenuData objLogMenu = new MenuData(strLogURL,
											"学習ログ",
											MenuData.DEFAULT_MENU,
											MenuData.ALL_MENU);
		// ウィンドウ表示方法を別ウィンドウに設定します。
			objLogMenu.setTargetWindow( "_blank" );
		return objLogMenu;
	}

	/**
	 * スマートフォース個別学習ログメニューオブジェクト作成<BR>
	 * @param Hashtable パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeIndividualLogMenu(Hashtable htbParam)
		throws LOException
	{
		String strLoType        = (String)htbParam.get(LO_TYPE);
		String strUserID        = (String)htbParam.get(TARGET_ID);
		String strLoID          = (String)htbParam.get(LOID);
		//ログ種別 0:受講者一覧 1:個人別一覧
		String strLogType       = "0";												// 受講者一覧
		if(strUserID != null && strUserID.indexOf("GR") == -1)
		{
			strLogType = "1";														// 個人別一覧
		}
		SmartForceLoEnv objEnv  = new SmartForceLoEnv();
		String strLogServletURL = objEnv.getLogServletURL();
		String strLogURL        = strLogServletURL + 
									"?userId=" + strUserID +
									"&LoID=" + strLoID +
									"&LoType=" + strLoType +
									"&LogType=" + strLogType;
		String strItemName      = "個別ログ(学習者一覧表示)";
		if(strLogType.equals("1"))
		{
			strItemName = "個別ログ(個人別一覧表示)";
		}
		MenuData objLogMenu = new MenuData(strLogURL,
											strItemName,
											MenuData.DEFAULT_MENU,
											MenuData.ALL_MENU);
		// ウィンドウ表示方法を別ウィンドウに設定します。
		objLogMenu.setTargetWindow( "_blank" );

		return objLogMenu;
	}

	/**
	 * スマートフォースLo登録メニューオブジェクト作成
	 *
	 * @param htbParam パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeInsertMenu(Hashtable htbParam)
		throws LOException
	{
		// 環境ファイル読み込みクラスをインスタンス化
		SmartForceLoEnv objEnv  = new SmartForceLoEnv();
		String strInsertMenuURL = objEnv.getInsertMenuURL();
		MenuData objMenu        = new MenuData(strInsertMenuURL,
												"SmartForceLo登録",
												MenuData.INSERT_MENU,
												MenuData.INSTRUCTOR_MENU);
		return objMenu;
	}

	/**
	 * スマートフォースLo更新メニューオブジェクト作成
	 *
	 * @param htbParam パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeUpdateMenu(Hashtable htbParam)
		throws LOException
	{
		// 環境ファイル読み込みクラスをインスタンス化
		SmartForceLoEnv objEnv  = new SmartForceLoEnv();
		String strUpdateMenuURL = objEnv.getUpdateMenuURL();
		MenuData objMenu        = new MenuData(strUpdateMenuURL,
												"SmartForceLo更新",
												MenuData.UPDATE_MENU,
												MenuData.INSTRUCTOR_MENU);
		return objMenu;
	}

	/**
	 * スマートフォースLo削除メニューオブジェクト作成
	 *
	 * @param htbParam パラメータ
	 * @return MenuData メニューデータ
	 * @exception LOException Lo固有の例外エラー
	 */
	private MenuData makeDeleteMenu(Hashtable htbParam)
		throws LOException
	{
		// 環境ファイル読み込みクラスをインスタンス化
		SmartForceLoEnv objEnv  = new SmartForceLoEnv();
		String strDeleteMenuURL = objEnv.getDeleteMenuURL();
		MenuData objMenu        = new MenuData(strDeleteMenuURL,
												"SmartForceLo削除",
												MenuData.DELETE_MENU,
												MenuData.INSTRUCTOR_MENU);
		return objMenu;
	}

	/**
	 * スマートフォース教材詳細情報を設定します
	 */
	private void setSmartForceLoData( Hashtable htbParam )
		throws LOException
	{
		// Dataアクセスクラスを使用して、詳細情報を取得する
		SmartForceLoDataAccess objDataAccess = new SmartForceLoDataAccess();
		Hashtable htbCondition = new Hashtable();
		String strRealLOID = (String)htbParam.get(REAL_LOID);
		if(strRealLOID != null){
			htbCondition.put(LOID, strRealLOID);
		}else{
			throw new LOException("RealLOIDを取得できません。");
		}
		SmartForceLoData[] objData = objDataAccess.getData( htbCondition );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// 教材IDの設定
			htbParam.put( COURSECODE, objData[i].getCourseCode() );
			htbParam.put( MATVERSION, objData[i].getVersion() );
		}
	}

}